# Class LatLng

java.lang.Object
com.codename1.maps.LatLng

public final class LatLng extends Object

An immutable WGS84 geographic coordinate (latitude/longitude in degrees).

Unlike the legacy `Coord`, `LatLng` is always unprojected (plain lat/lon) and immutable, which makes it safe to share between the map components, the vector engine and native providers. It is the value type used throughout the modern maps API (`MapView`, `NativeMap` and `MapProvider`).

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `LatLng(double latitude, double longitude)`
  Creates a coordinate from a latitude/longitude pair in degrees.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static LatLng`
  `create(double latitude, double longitude)`
  Factory method mirroring the constructor for fluent call sites.
  `double`
  `distanceTo(LatLng other)`
  The great-circle distance in meters between this coordinate and `other`, computed with the haversine formula.
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `static LatLng`
  `fromCoord(Coord c)`
  Converts a legacy `Coord` (assumed WGS84) into a `LatLng`.
  `double`
  `getLatitude()`
  The latitude in degrees in the range [-90, 90].
  `double`
  `getLongitude()`
  The longitude in degrees in the range [-180, 180].
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `Coord`
  `toCoord()`
  Converts this coordinate into a legacy WGS84 `Coord`.
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### LatLng

    public LatLng(double latitude, double longitude)

    Creates a coordinate from a latitude/longitude pair in degrees.

    ###### Parameters

    - `latitude`: the latitude in degrees, clamped to the valid range

    - `longitude`: the longitude in degrees, normalized to [-180, 180]

- ## Method Details

  - ### create

    public static LatLng create(double latitude, double longitude)
    Factory method mirroring the constructor for fluent call sites.

  - ### fromCoord

    public static LatLng fromCoord(Coord c)
    Converts a legacy `Coord` (assumed WGS84) into a `LatLng`.

  - ### getLatitude

    public double getLatitude()
    The latitude in degrees in the range [-90, 90].

  - ### getLongitude

    public double getLongitude()
    The longitude in degrees in the range [-180, 180].

  - ### toCoord

    public Coord toCoord()
    Converts this coordinate into a legacy WGS84 `Coord`.

  - ### distanceTo

    public double distanceTo(LatLng other)
    The great-circle distance in meters between this coordinate and `other`, computed with the haversine formula.

  - ### equals

    public boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`

  - ### toString

    public String toString()
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`